// xcomplejo.cpp
// Banco de pruebas de la clase complejo

//----Cabeceras ---
// biblioteca estndar
#include <iostream>  
#include <iomanip>
#include <string>
// control de errores
#include <error.h>
// utilidades matemticas
#include <matutil.h>
// Clase complejos
#include <complejo.h>

// Espacio de nombres estndar
using namespace std;

//---main---

int main () 
{      
    // Constructor estndar;
    double real, imag;
    cout << "introduzca la parte real de z1 "; cin>>real;
    cout << "introduzca la parte imaginaria de z1 "; cin>>imag;
    Complejo z1(real,imag);
    cout << "creado nmero complejo z1 = " << z1 << endl;

    // Devuelve parte real e imaginaria de z1
    cout << " Re(z1) = " << z1.real()
	 << " Im(z1) = " << z1.imag()
	 << endl;

    // Constructor por defecto
    Complejo z2;
    cout << "creado nmero complejo z2 = " << z2 << endl;

    // Asigna parte real e imaginaria
    cout << "introduzca la parte real de z2 "; 
    cin>> z2.real();
    cout << "introduzca la parte imaginaria de z2 "; 
    cin >> z2.imag();

    // Devuelve parte real e imaginaria de z2
    cout << " Re(z2) = " << z2.real()
	 << " Im(z2) = " << z2.imag()
	 << endl;

    // operador -
    cout << "compruebo operador cambio de signo -z1 = " 
	 << -z1 << endl;
	
    // operador =
    Complejo z3 = z1; // asigna el valor de z1 a z3
    cout << "compruebo operador de asignacin z3 = z" 
	 << z3 << endl;

    // operaciones
    cout << "compruebo suma, z1 + z2 = " 
	 << z1 + z2 << endl;
    cout << "compruebo resta, z1 - z2 = " 
	 << z1 - z2 << endl;
    cout << "compruebo multiplicacin, z1 * z2 = " 
	 << z1 * z2 << endl;
    cout << "compruebo divisin, z1/z2 = " 
	 << z1/z2 << endl;

    // funciones
    cout << "compruebo valor absoluto modulo(z1) = " 
	 << modulo(z1) << endl;
    cout << "compruebo valor absoluto al cuadrado modulo2(z1) = " 
	 << modulo2(z1) << endl;
    cout << "compruebo conjugado conjugado(z1) = " 
	 << conjugado(z1) << endl;
    cout << "compruebo inverso inverso(z1) = " 
	 << inverso(z1) << endl;

    // composicin de operadores
    cout << "encadeno operadores, modulo(conjugado(inverso(z1+z2*z3)="
	 << modulo(conjugado(inverso(z1+z2*z3))) 
	 << endl;

    return EXITO; 
} 













